Index: trunk/modules/vci_block_device_tsar_v4/caba/source/include/vci_block_device_tsar_v4.h
===================================================================
--- trunk/modules/vci_block_device_tsar_v4/caba/source/include/vci_block_device_tsar_v4.h	(revision 151)
+++ trunk/modules/vci_block_device_tsar_v4/caba/source/include/vci_block_device_tsar_v4.h	(revision 164)
@@ -78,4 +78,5 @@
 #include "caba_base_module.h"
 #include "mapping_table.h"
+#include "vci_target.h"
 
 namespace soclib {
@@ -103,7 +104,7 @@
     sc_signal<uint32_t>       		r_latency_count;	// latency access (for each block)
     sc_signal<bool>           		r_go;           	// transmit command from T_FSM to M_FSM
-    sc_signal<sc_uint<vci_param::S> >	r_srcid;		// save srcid
-    sc_signal<sc_uint<vci_param::T> >	r_trdid;		// save trdid
-    sc_signal<sc_uint<vci_param::P> >	r_pktid;		// save pktid
+    sc_signal<sc_dt::sc_uint<vci_param::S> >	r_srcid;		// save srcid
+    sc_signal<sc_dt::sc_uint<vci_param::T> >	r_trdid;		// save trdid
+    sc_signal<sc_dt::sc_uint<vci_param::P> >	r_pktid;		// save pktid
 
     uint32_t*   			m_local_buffer; 	// capacity is one block (block_size bytes)
@@ -111,5 +112,5 @@
     // structural parameters
     soclib::common::Segment     	m_segment;      	// segment associated to target
-    uint32_t              		m_srcid;        	// initiator index
+    uint32_t                  		m_srcid;        	// initiator index
     int                         	m_fd;           	// File descriptor
     uint64_t                    	m_device_size;  	// Total number of blocks
@@ -174,9 +175,9 @@
 
     // ports
-    sc_in<bool> 					p_clk;
-    sc_in<bool> 					p_resetn;
-    soclib::caba::VciInitiator<vci_param> 		p_vci_initiator;
-    soclib::caba::VciTarget<vci_param> 			p_vci_target;
-    sc_out<bool> 					p_irq;
+    sc_in<bool> 					      p_clk;
+    sc_in<bool> 					      p_resetn;
+    soclib::caba::VciInitiator<vci_param> p_vci_initiator;
+    soclib::caba::VciTarget<vci_param>    p_vci_target;
+    sc_out<bool> 					      p_irq;
 
     void print_trace();
Index: trunk/modules/vci_block_device_tsar_v4/caba/source/src/vci_block_device_tsar_v4.cpp
===================================================================
--- trunk/modules/vci_block_device_tsar_v4/caba/source/src/vci_block_device_tsar_v4.cpp	(revision 151)
+++ trunk/modules/vci_block_device_tsar_v4/caba/source/src/vci_block_device_tsar_v4.cpp	(revision 164)
@@ -27,8 +27,8 @@
  */
 
-#include "vci_block_device_tsar_v4.h"
 #include <stdint.h>
 #include <iostream>
 #include <fcntl.h>
+#include "vci_block_device_tsar_v4.h"
 
 namespace soclib { namespace caba {
@@ -64,5 +64,5 @@
             r_trdid = p_vci_target.trdid.read();
             r_pktid = p_vci_target.pktid.read();
-	    sc_uint<vci_param::N> address = p_vci_target.address.read();
+	    sc_dt::sc_uint<vci_param::N> address = p_vci_target.address.read();
             bool                  read    = (p_vci_target.cmd.read() == vci_param::CMD_READ);
             uint32_t              cell    = (uint32_t)((address & 0x1F)>>2);
@@ -335,11 +335,11 @@
 tmpl(void)::genMoore()
 {
-    sc_uint<vci_param::N> 	offset;
+    sc_dt::sc_uint<vci_param::N> 	offset;
     uint32_t			index;
 
     // p_vci_target port   
-    p_vci_target.rsrcid = (sc_uint<vci_param::S>)r_srcid.read();
-    p_vci_target.rtrdid = (sc_uint<vci_param::T>)r_trdid.read();
-    p_vci_target.rpktid = (sc_uint<vci_param::P>)r_pktid.read();
+    p_vci_target.rsrcid = (sc_dt::sc_uint<vci_param::S>)r_srcid.read();
+    p_vci_target.rtrdid = (sc_dt::sc_uint<vci_param::T>)r_trdid.read();
+    p_vci_target.rpktid = (sc_dt::sc_uint<vci_param::P>)r_pktid.read();
     p_vci_target.reop   = true;
 
@@ -417,5 +417,5 @@
 
     // p_vci_initiator port
-    p_vci_initiator.srcid  = (sc_uint<vci_param::S>)m_srcid;
+    p_vci_initiator.srcid  = (sc_dt::sc_uint<vci_param::S>)m_srcid;
     p_vci_initiator.trdid  = 0;
     p_vci_initiator.pktid  = 0;
@@ -432,9 +432,9 @@
         p_vci_initiator.rspack  = false;
         p_vci_initiator.cmdval  = true;
-        p_vci_initiator.address = (sc_uint<vci_param::N>)r_buf_address.read() + offset;
+        p_vci_initiator.address = (sc_dt::sc_uint<vci_param::N>)r_buf_address.read() + offset;
         p_vci_initiator.cmd     = vci_param::CMD_READ;
         p_vci_initiator.wdata   = 0;
         p_vci_initiator.be      = (uint32_t)0xF;
-        p_vci_initiator.plen    = (sc_uint<vci_param::K>)m_flits_per_burst*vci_param::B;
+        p_vci_initiator.plen    = (sc_dt::sc_uint<vci_param::K>)m_flits_per_burst*vci_param::B;
         p_vci_initiator.eop     = true;
         break;
@@ -446,9 +446,9 @@
         p_vci_initiator.rspack  = false;
         p_vci_initiator.cmdval  = true;
-        p_vci_initiator.address = (sc_uint<vci_param::N>)r_buf_address.read() + offset; 
+        p_vci_initiator.address = (sc_dt::sc_uint<vci_param::N>)r_buf_address.read() + offset; 
         p_vci_initiator.cmd     = vci_param::CMD_WRITE;
         p_vci_initiator.wdata   = (uint32_t)m_local_buffer[index];
         p_vci_initiator.be      = 0xF;
-        p_vci_initiator.plen    = (sc_uint<vci_param::K>)m_flits_per_burst*vci_param::B;
+        p_vci_initiator.plen    = (sc_dt::sc_uint<vci_param::K>)m_flits_per_burst*vci_param::B;
         p_vci_initiator.eop     = ( r_flit_count.read() == (m_flits_per_burst - 1) );
         break;