Index: trunk/platforms/caba-vdspin-vci_synthetic_initiator/top.cpp
===================================================================
--- trunk/platforms/caba-vdspin-vci_synthetic_initiator/top.cpp	(revision 179)
+++ trunk/platforms/caba-vdspin-vci_synthetic_initiator/top.cpp	(revision 182)
@@ -10,5 +10,5 @@
 #include "mapping_table.h"
 #include "alloc_elems.h"
-#include "vci_simple_ram.h"
+#include "vci_synthetic_target.h"
 #include "vci_local_ring_fast.h"
 #include "virtual_dspin_router.h"
@@ -178,6 +178,6 @@
 		}
 
-	soclib::caba::VciSimpleRam<vci_param> * ram_c0 = (soclib::caba::VciSimpleRam<vci_param> *) malloc(sizeof(soclib::caba::VciSimpleRam<vci_param>) * N_CLUSTERS);
-	soclib::caba::VciSimpleRam<vci_param> * ram_c1 = (soclib::caba::VciSimpleRam<vci_param> *) malloc(sizeof(soclib::caba::VciSimpleRam<vci_param>) * N_CLUSTERS);
+	soclib::caba::VciSyntheticTarget<vci_param> * target_c0 = (soclib::caba::VciSyntheticTarget<vci_param> *) malloc(sizeof(soclib::caba::VciSyntheticTarget<vci_param>) * N_CLUSTERS);
+	soclib::caba::VciSyntheticTarget<vci_param> * target_c1 = (soclib::caba::VciSyntheticTarget<vci_param> *) malloc(sizeof(soclib::caba::VciSyntheticTarget<vci_param>) * N_CLUSTERS);
 	for(int i = 0 ; i < X_MAX ; i++)
 		for(int j = 0 ; j < Y_MAX ; j++){
@@ -186,6 +186,6 @@
 			str0 << "Ram_c0_" << (i*Y_MAX+j) ;
 			str1 << "Ram_c1_" << (i*Y_MAX+j) ;
-			new(&ram_c0[Y_MAX*i+j]) soclib::caba::VciSimpleRam<vci_param> (str0.str().c_str() , IntTab(i*Y_MAX+j,0), maptab0, soclib::common::Loader(), 0);
-			new(&ram_c1[Y_MAX*i+j]) soclib::caba::VciSimpleRam<vci_param> (str1.str().c_str() , IntTab(i*Y_MAX+j,0), maptab1, soclib::common::Loader(), 0);
+			new(&target_c0[Y_MAX*i+j]) soclib::caba::VciSyntheticTarget<vci_param> (str0.str().c_str() , IntTab(i*Y_MAX+j,0), maptab0, soclib::common::Loader(), 0);
+			new(&target_c1[Y_MAX*i+j]) soclib::caba::VciSyntheticTarget<vci_param> (str1.str().c_str() , IntTab(i*Y_MAX+j,0), maptab1, soclib::common::Loader(), 0);
 		}
 
@@ -201,7 +201,7 @@
 	  initiator_c0[i].p_resetn(signal_resetn);
 	  initiator_c0[i].p_vci(signal_vci_ini_synth_c0[0][i]);
-	  ram_c0[i].p_clk(signal_clk);
-	  ram_c0[i].p_resetn(signal_resetn);
-	  ram_c0[i].p_vci(signal_vci_ini_synth_c0[1][i]);
+	  target_c0[i].p_clk(signal_clk);
+	  target_c0[i].p_resetn(signal_resetn);
+	  target_c0[i].p_vci(signal_vci_ini_synth_c0[1][i]);
 	  local_ring_c1[i].p_clk(signal_clk);
 	  local_ring_c1[i].p_resetn(signal_resetn);
@@ -211,7 +211,7 @@
 	  initiator_c1[i].p_resetn(signal_resetn);
 	  initiator_c1[i].p_vci(signal_vci_ini_synth_c1[0][i]);
-	  ram_c1[i].p_clk(signal_clk);
-	  ram_c1[i].p_resetn(signal_resetn);
-	  ram_c1[i].p_vci(signal_vci_ini_synth_c1[1][i]);
+	  target_c1[i].p_clk(signal_clk);
+	  target_c1[i].p_resetn(signal_resetn);
+	  target_c1[i].p_vci(signal_vci_ini_synth_c1[1][i]);
 	}
 	
@@ -371,5 +371,5 @@
 		//initiator_c1[4].print_trace();
 		//local_ring_c1[4].print_trace();
-		//ram_c1[4].print_trace();
+		//target_c1[4].print_trace();
 #if defined(DEBUG) 
 		for(int i = 0 ; i < Y_MAX ; i++){
@@ -394,19 +394,19 @@
 				//std::cout << "synt_rerror  = " << signal_vci_ini_synth_c0[0][i*Y_MAX+j].rerror.read() << std::endl;
 				//std::cout << "synt_reop    = " << signal_vci_ini_synth_c0[0][i*Y_MAX+j].reop.read() << std::endl;
-				//ram_c0[i*Y_MAX+j].print_trace();
+				//target_c0[i*Y_MAX+j].print_trace();
 				//std::cout << std::hex;
-				//std::cout << "ram_cmdval  = " << signal_vci_ini_synth_c0[1][i*Y_MAX+j].cmdval.read() << std::endl;
-				//std::cout << "ram_address = " << signal_vci_ini_synth_c0[1][i*Y_MAX+j].address.read() << std::endl;
-				//std::cout << "ram_cmd     = " << signal_vci_ini_synth_c0[1][i*Y_MAX+j].cmd.read() << std::endl;
-				//std::cout << "ram_srcid   = " << signal_vci_ini_synth_c0[1][i*Y_MAX+j].srcid.read() << std::endl;
-				//std::cout << "ram_trdid   = " << signal_vci_ini_synth_c0[1][i*Y_MAX+j].trdid.read() << std::endl;
-				//std::cout << "ram_plen    = " << signal_vci_ini_synth_c0[1][i*Y_MAX+j].plen.read() << std::endl;
-				//std::cout << "ram_eop     = " << signal_vci_ini_synth_c0[1][i*Y_MAX+j].eop.read() << std::endl;
-				//std::cout << "ram_rspval  = " << signal_vci_ini_synth_c0[1][i*Y_MAX+j].rspval.read() << std::endl;
-				//std::cout << "ram_rspack  = " << signal_vci_ini_synth_c0[1][i*Y_MAX+j].rspack.read() << std::endl;
-				//std::cout << "ram_rsrcid  = " << signal_vci_ini_synth_c0[1][i*Y_MAX+j].rsrcid.read() << std::endl;
-				//std::cout << "ram_rtrdid  = " << signal_vci_ini_synth_c0[1][i*Y_MAX+j].rtrdid.read() << std::endl;
-				//std::cout << "ram_rerror  = " << signal_vci_ini_synth_c0[1][i*Y_MAX+j].rerror.read() << std::endl;
-				//std::cout << "ram_reop    = " << signal_vci_ini_synth_c0[1][i*Y_MAX+j].reop.read() << std::endl;
+				//std::cout << "target_cmdval  = " << signal_vci_ini_synth_c0[1][i*Y_MAX+j].cmdval.read() << std::endl;
+				//std::cout << "target_address = " << signal_vci_ini_synth_c0[1][i*Y_MAX+j].address.read() << std::endl;
+				//std::cout << "target_cmd     = " << signal_vci_ini_synth_c0[1][i*Y_MAX+j].cmd.read() << std::endl;
+				//std::cout << "target_srcid   = " << signal_vci_ini_synth_c0[1][i*Y_MAX+j].srcid.read() << std::endl;
+				//std::cout << "target_trdid   = " << signal_vci_ini_synth_c0[1][i*Y_MAX+j].trdid.read() << std::endl;
+				//std::cout << "target_plen    = " << signal_vci_ini_synth_c0[1][i*Y_MAX+j].plen.read() << std::endl;
+				//std::cout << "target_eop     = " << signal_vci_ini_synth_c0[1][i*Y_MAX+j].eop.read() << std::endl;
+				//std::cout << "target_rspval  = " << signal_vci_ini_synth_c0[1][i*Y_MAX+j].rspval.read() << std::endl;
+				//std::cout << "target_rspack  = " << signal_vci_ini_synth_c0[1][i*Y_MAX+j].rspack.read() << std::endl;
+				//std::cout << "target_rsrcid  = " << signal_vci_ini_synth_c0[1][i*Y_MAX+j].rsrcid.read() << std::endl;
+				//std::cout << "target_rtrdid  = " << signal_vci_ini_synth_c0[1][i*Y_MAX+j].rtrdid.read() << std::endl;
+				//std::cout << "target_rerror  = " << signal_vci_ini_synth_c0[1][i*Y_MAX+j].rerror.read() << std::endl;
+				//std::cout << "target_reop    = " << signal_vci_ini_synth_c0[1][i*Y_MAX+j].reop.read() << std::endl;
 				//initiator_c1[i*Y_MAX+j].print_trace();
 				//std::cout << std::hex;
@@ -427,21 +427,21 @@
 				//std::cout << "synt_rerror  = " << signal_vci_ini_synth_c1[0][i*Y_MAX+j].rerror.read() << std::endl;
 				//std::cout << "synt_reop    = " << signal_vci_ini_synth_c1[0][i*Y_MAX+j].reop.read() << std::endl;
-				ram_c1[i*Y_MAX+j].print_trace();
+				target_c1[i*Y_MAX+j].print_trace();
 				std::cout << std::hex;
-				std::cout << "ram_cmdval  = " << signal_vci_ini_synth_c1[1][i*Y_MAX+j].cmdval.read() << std::endl;
-				std::cout << "ram_address = " << signal_vci_ini_synth_c1[1][i*Y_MAX+j].address.read() << std::endl;
-				std::cout << "ram_cmd     = " << signal_vci_ini_synth_c1[1][i*Y_MAX+j].cmd.read() << std::endl;
-				std::cout << "ram_srcid   = " << signal_vci_ini_synth_c1[1][i*Y_MAX+j].srcid.read() << std::endl;
-				std::cout << "ram_trdid   = " << signal_vci_ini_synth_c1[1][i*Y_MAX+j].trdid.read() << std::endl;
-				std::cout << "ram_pktid   = " << signal_vci_ini_synth_c1[1][i*Y_MAX+j].pktid.read() << std::endl;
-				std::cout << "ram_plen    = " << signal_vci_ini_synth_c1[1][i*Y_MAX+j].plen.read() << std::endl;
-				std::cout << "ram_eop     = " << signal_vci_ini_synth_c1[1][i*Y_MAX+j].eop.read() << std::endl;
-				std::cout << "ram_rspval  = " << signal_vci_ini_synth_c1[1][i*Y_MAX+j].rspval.read() << std::endl;
-				std::cout << "ram_rspack  = " << signal_vci_ini_synth_c1[1][i*Y_MAX+j].rspack.read() << std::endl;
-				std::cout << "ram_rsrcid  = " << signal_vci_ini_synth_c1[1][i*Y_MAX+j].rsrcid.read() << std::endl;
-				std::cout << "ram_rtrdid  = " << signal_vci_ini_synth_c1[1][i*Y_MAX+j].rtrdid.read() << std::endl;
-				std::cout << "ram_rpktid  = " << signal_vci_ini_synth_c1[1][i*Y_MAX+j].rpktid.read() << std::endl;
-				std::cout << "ram_rerror  = " << signal_vci_ini_synth_c1[1][i*Y_MAX+j].rerror.read() << std::endl;
-				std::cout << "ram_reop    = " << signal_vci_ini_synth_c1[1][i*Y_MAX+j].reop.read() << std::endl;
+				std::cout << "target_cmdval  = " << signal_vci_ini_synth_c1[1][i*Y_MAX+j].cmdval.read() << std::endl;
+				std::cout << "target_address = " << signal_vci_ini_synth_c1[1][i*Y_MAX+j].address.read() << std::endl;
+				std::cout << "target_cmd     = " << signal_vci_ini_synth_c1[1][i*Y_MAX+j].cmd.read() << std::endl;
+				std::cout << "target_srcid   = " << signal_vci_ini_synth_c1[1][i*Y_MAX+j].srcid.read() << std::endl;
+				std::cout << "target_trdid   = " << signal_vci_ini_synth_c1[1][i*Y_MAX+j].trdid.read() << std::endl;
+				std::cout << "target_pktid   = " << signal_vci_ini_synth_c1[1][i*Y_MAX+j].pktid.read() << std::endl;
+				std::cout << "target_plen    = " << signal_vci_ini_synth_c1[1][i*Y_MAX+j].plen.read() << std::endl;
+				std::cout << "target_eop     = " << signal_vci_ini_synth_c1[1][i*Y_MAX+j].eop.read() << std::endl;
+				std::cout << "target_rspval  = " << signal_vci_ini_synth_c1[1][i*Y_MAX+j].rspval.read() << std::endl;
+				std::cout << "target_rspack  = " << signal_vci_ini_synth_c1[1][i*Y_MAX+j].rspack.read() << std::endl;
+				std::cout << "target_rsrcid  = " << signal_vci_ini_synth_c1[1][i*Y_MAX+j].rsrcid.read() << std::endl;
+				std::cout << "target_rtrdid  = " << signal_vci_ini_synth_c1[1][i*Y_MAX+j].rtrdid.read() << std::endl;
+				std::cout << "target_rpktid  = " << signal_vci_ini_synth_c1[1][i*Y_MAX+j].rpktid.read() << std::endl;
+				std::cout << "target_rerror  = " << signal_vci_ini_synth_c1[1][i*Y_MAX+j].rerror.read() << std::endl;
+				std::cout << "target_reop    = " << signal_vci_ini_synth_c1[1][i*Y_MAX+j].reop.read() << std::endl;
 #endif
 #if DEBUG==2
@@ -473,21 +473,21 @@
 				//std::cout << "synt_rerror  = " << signal_vci_ini_synth_c1[0][255].rerror.read() << std::endl;
 				//std::cout << "synt_reop    = " << signal_vci_ini_synth_c1[0][255].reop.read() << std::endl;
-				//ram_c1[4].print_trace();
+				//target_c1[4].print_trace();
 				//std::cout << std::hex;
-				//std::cout << "ram_cmdval  = " << signal_vci_ini_synth_c1[1][4].cmdval.read() << std::endl;
-				//std::cout << "ram_address = " << signal_vci_ini_synth_c1[1][4].address.read() << std::endl;
-				//std::cout << "ram_cmd     = " << signal_vci_ini_synth_c1[1][4].cmd.read() << std::endl;
-				//std::cout << "ram_srcid   = " << signal_vci_ini_synth_c1[1][4].srcid.read() << std::endl;
-				//std::cout << "ram_trdid   = " << signal_vci_ini_synth_c1[1][4].trdid.read() << std::endl;
-				//std::cout << "ram_pktid   = " << signal_vci_ini_synth_c1[1][4].pktid.read() << std::endl;
-				//std::cout << "ram_plen    = " << signal_vci_ini_synth_c1[1][4].plen.read() << std::endl;
-				//std::cout << "ram_eop     = " << signal_vci_ini_synth_c1[1][4].eop.read() << std::endl;
-				//std::cout << "ram_rspval  = " << signal_vci_ini_synth_c1[1][4].rspval.read() << std::endl;
-				//std::cout << "ram_rspack  = " << signal_vci_ini_synth_c1[1][4].rspack.read() << std::endl;
-				//std::cout << "ram_rsrcid  = " << signal_vci_ini_synth_c1[1][4].rsrcid.read() << std::endl;
-				//std::cout << "ram_rtrdid  = " << signal_vci_ini_synth_c1[1][4].rtrdid.read() << std::endl;
-				//std::cout << "ram_rpktid  = " << signal_vci_ini_synth_c1[1][4].rpktid.read() << std::endl;
-				//std::cout << "ram_rerror  = " << signal_vci_ini_synth_c1[1][4].rerror.read() << std::endl;
-				//std::cout << "ram_reop    = " << signal_vci_ini_synth_c1[1][4].reop.read() << std::endl;
+				//std::cout << "target_cmdval  = " << signal_vci_ini_synth_c1[1][4].cmdval.read() << std::endl;
+				//std::cout << "target_address = " << signal_vci_ini_synth_c1[1][4].address.read() << std::endl;
+				//std::cout << "target_cmd     = " << signal_vci_ini_synth_c1[1][4].cmd.read() << std::endl;
+				//std::cout << "target_srcid   = " << signal_vci_ini_synth_c1[1][4].srcid.read() << std::endl;
+				//std::cout << "target_trdid   = " << signal_vci_ini_synth_c1[1][4].trdid.read() << std::endl;
+				//std::cout << "target_pktid   = " << signal_vci_ini_synth_c1[1][4].pktid.read() << std::endl;
+				//std::cout << "target_plen    = " << signal_vci_ini_synth_c1[1][4].plen.read() << std::endl;
+				//std::cout << "target_eop     = " << signal_vci_ini_synth_c1[1][4].eop.read() << std::endl;
+				//std::cout << "target_rspval  = " << signal_vci_ini_synth_c1[1][4].rspval.read() << std::endl;
+				//std::cout << "target_rspack  = " << signal_vci_ini_synth_c1[1][4].rspack.read() << std::endl;
+				//std::cout << "target_rsrcid  = " << signal_vci_ini_synth_c1[1][4].rsrcid.read() << std::endl;
+				//std::cout << "target_rtrdid  = " << signal_vci_ini_synth_c1[1][4].rtrdid.read() << std::endl;
+				//std::cout << "target_rpktid  = " << signal_vci_ini_synth_c1[1][4].rpktid.read() << std::endl;
+				//std::cout << "target_rerror  = " << signal_vci_ini_synth_c1[1][4].rerror.read() << std::endl;
+				//std::cout << "target_reop    = " << signal_vci_ini_synth_c1[1][4].reop.read() << std::endl;
 			
 			//for(int i = 0 ; i < Y_MAX ; i++){