Index: trunk/modules/vci_vdspin_initiator_wrapper/caba/source/src/vci_vdspin_initiator_wrapper.cpp
===================================================================
--- trunk/modules/vci_vdspin_initiator_wrapper/caba/source/src/vci_vdspin_initiator_wrapper.cpp	(revision 153)
+++ trunk/modules/vci_vdspin_initiator_wrapper/caba/source/src/vci_vdspin_initiator_wrapper.cpp	(revision 186)
@@ -126,18 +126,18 @@
                     {
                         r_cmd_fsm     = CMD_BROADCAST;
-                        cmd_fifo_data = (address      & 0x7FFFF80000) |
-                                        ((srcid << 5) & 0x000007FFE0) | 
-                                        ((trdid << 1) & 0x000000001E) | 
-                                                        0x0000000001;		
+                        cmd_fifo_data = (address      & 0x7FFFF80000LL) |
+                                        ((srcid << 5) & 0x000007FFE0LL) | 
+                                        ((trdid << 1) & 0x000000001ELL) | 
+                                                        0x0000000001LL;		
                     }
                     else if (is_read )			// VCI READ  command
                     {
 		        r_cmd_fsm     = CMD_READ;
-                        cmd_fifo_data = address & 0x7FFFFFFFFE;
+                        cmd_fifo_data = address & 0x7FFFFFFFFELL;
 		    }
                     else 				// VCI WRITE command
                     {
 		        r_cmd_fsm     = CMD_WRITE;
-                        cmd_fifo_data = address & 0x7FFFFFFFFE;
+                        cmd_fifo_data = address & 0x7FFFFFFFFELL;
 		    }
 		}
@@ -151,7 +151,7 @@
                     sc_uint<dspin_cmd_width> data = (sc_uint<dspin_cmd_width>)p_vci.wdata.read();
                     sc_uint<dspin_cmd_width> be   = (sc_uint<dspin_cmd_width>)p_vci.be.read();
-                    cmd_fifo_data    = (data       & 0x00FFFFFFFF) | 
-                                       ((be << 32) & 0x0300000000) |
-                                                     0x8000000000; 
+                    cmd_fifo_data    = (data       & 0x00FFFFFFFFLL) | 
+                                       ((be << 32) & 0x0300000000LL) |
+                                                     0x8000000000LL; 
                     r_cmd_fsm = CMD_IDLE;
                 }
@@ -169,16 +169,16 @@
                     sc_uint<dspin_cmd_width> plen    = (sc_uint<dspin_cmd_width>)p_vci.plen.read();
                     sc_uint<dspin_cmd_width> be      = (sc_uint<dspin_cmd_width>)p_vci.be.read();
-		    cmd_fifo_data       = ((be    << 1 ) & 0x000000001E) |
-                                          ((trdid << 5 ) & 0x0000001FE0) |
-                                          ((plen  << 13) & 0x00001FE000) |
-                                          ((cmd   << 23) & 0x0001800000) |
-                                          ((srcid << 25) & 0x7FFE000000) ;
-                    if ( p_vci.contig.read() ) cmd_fifo_data = cmd_fifo_data | 0x0000400000 ;
-                    if ( p_vci.cons.read()   ) cmd_fifo_data = cmd_fifo_data | 0x0000200000 ;
+		    cmd_fifo_data       = ((be    << 1 ) & 0x000000001ELL) |
+                                          ((trdid << 5 ) & 0x0000001FE0LL) |
+                                          ((plen  << 13) & 0x00001FE000LL) |
+                                          ((cmd   << 23) & 0x0001800000LL) |
+                                          ((srcid << 25) & 0x7FFE000000LL) ;
+                    if ( p_vci.contig.read() ) cmd_fifo_data = cmd_fifo_data | 0x0000400000LL ;
+                    if ( p_vci.cons.read()   ) cmd_fifo_data = cmd_fifo_data | 0x0000200000LL ;
 
                     if( r_cmd_fsm == CMD_READ )  // read command
                     {
                         r_cmd_fsm = CMD_IDLE;
-                        cmd_fifo_data = cmd_fifo_data    | 0x8000000000 ;
+                        cmd_fifo_data = cmd_fifo_data    | 0x8000000000LL ;
                     }
                     else			// write command
@@ -196,10 +196,10 @@
                     sc_uint<dspin_cmd_width> data = (sc_uint<dspin_cmd_width>)p_vci.wdata.read();
                     sc_uint<dspin_cmd_width> be   = (sc_uint<dspin_cmd_width>)p_vci.be.read();
-		    cmd_fifo_data    = (data       & 0x00FFFFFFFF) | 
-                                       ((be << 32) & 0x0F00000000) ;
+		    cmd_fifo_data    = (data       & 0x00FFFFFFFFLL) | 
+                                       ((be << 32) & 0x0F00000000LL) ;
                                        
                     if ( p_vci.eop.read() )
                     {
-                        cmd_fifo_data = cmd_fifo_data | 0x8000000000;
+                        cmd_fifo_data = cmd_fifo_data | 0x8000000000LL;
                         r_cmd_fsm = CMD_IDLE;
                     }
@@ -242,6 +242,6 @@
 		    rsp_fifo_read = true;
                     r_rsp_buf = r_fifo_rsp.read();
-                    if ( (r_fifo_rsp.read() & 0x000020000) == 0 )  r_rsp_fsm = RSP_READ;
-                    else 					   r_rsp_fsm = RSP_WRITE;
+                    if ( (r_fifo_rsp.read() & 0x000020000LL) == 0 )  r_rsp_fsm = RSP_READ;
+                    else 				             r_rsp_fsm = RSP_WRITE;
 		}
 		break;
@@ -252,5 +252,5 @@
                 {
 		    rsp_fifo_read = true;
-                    if ( (r_fifo_rsp.read() & 0x100000000) ) r_rsp_fsm = RSP_IDLE;
+                    if ( (r_fifo_rsp.read() & 0x100000000LL) ) r_rsp_fsm = RSP_IDLE;
 		}
 		break;
@@ -291,8 +291,8 @@
             p_vci.rspval = true;
 	    p_vci.rdata  = 0;
-            p_vci.rsrcid = (sc_uint<vci_param::S>)((r_rsp_buf.read() & 0x0FFFC0000) >> 18);
-            p_vci.rtrdid = (sc_uint<vci_param::T>)((r_rsp_buf.read() & 0x00000FF00) >> 8);
+            p_vci.rsrcid = (sc_uint<vci_param::S>)((r_rsp_buf.read() & 0x0FFFC0000LL) >> 18);
+            p_vci.rtrdid = (sc_uint<vci_param::T>)((r_rsp_buf.read() & 0x00000FF00LL) >> 8);
             p_vci.rpktid = 0;
-            p_vci.rerror = (sc_uint<vci_param::E>)((r_rsp_buf.read() & 0x000030000) >> 16);
+            p_vci.rerror = (sc_uint<vci_param::E>)((r_rsp_buf.read() & 0x000030000LL) >> 16);
             p_vci.reop   = true;
         }
@@ -300,10 +300,10 @@
         {
             p_vci.rspval = r_fifo_rsp.rok();
-            p_vci.rdata  = (sc_uint<8*vci_param::B>)(r_fifo_rsp.read() & 0x0FFFFFFFF);
-            p_vci.rsrcid = (sc_uint<vci_param::S>)((r_rsp_buf.read()   & 0x0FFFC0000) >> 18);
-            p_vci.rtrdid = (sc_uint<vci_param::T>)((r_rsp_buf.read()   & 0x00000FF00) >> 8);
+            p_vci.rdata  = (sc_uint<8*vci_param::B>)(r_fifo_rsp.read() & 0x0FFFFFFFFLL);
+            p_vci.rsrcid = (sc_uint<vci_param::S>)((r_rsp_buf.read()   & 0x0FFFC0000LL) >> 18);
+            p_vci.rtrdid = (sc_uint<vci_param::T>)((r_rsp_buf.read()   & 0x00000FF00LL) >> 8);
             p_vci.rpktid = 0;
-            p_vci.rerror = (sc_uint<vci_param::E>)((r_rsp_buf.read()   & 0x000030000) >> 16);
-            p_vci.reop   = ((r_fifo_rsp.read() & 0x100000000) == 0x100000000); 
+            p_vci.rerror = (sc_uint<vci_param::E>)((r_rsp_buf.read()   & 0x000030000LL) >> 16);
+            p_vci.reop   = ((r_fifo_rsp.read() & 0x100000000LL) == 0x100000000LL); 
         }
 